//
//  ScanViewController.swift
//  Alamofire
//
//  Created by VCS on 20/04/19.
//

import UIKit
import Foundation
import MTBBarcodeScanner
import AVFoundation

class ScanViewController: UIViewController {
     // @IBOutlet var previewView: UIView!
     var scanner: MTBBarcodeScanner?
     var itesm = [String]()
     // @IBOutlet var countButton: UIButton!
     //var delegate:BarcodeScannerViewControllerDelegate!
     var isSingleScan:Bool = true
     var isPlaySound:Bool = true
     var isOnFlase:Bool = true
     
     var previewView:UIView!
     var scanRect:ScannerOverlay!
     //var scanner:MTBBarcodeScanner!
     
     //var isFlashOn:Bool = false
     
     override func viewDidLoad() {
          super.viewDidLoad()
          
          /*let key = "B4V2A1C@S#S$F"
           let iv = "0000000000000000"
           let s = "Vcs@1234"
           let enc = try! s.aesEncrypt1(key: key, iv: iv)
           print(enc)
           
           do{
           let dec = try enc.aesDecrypt1(key: key, iv: iv)
           print("dec:\(dec)")
           print("\(s == dec)")
           
           }catch let error {
           print("error:\(error)")
           }*/
          
          //self.countButton.setTitle("0", for: .normal)
          
          //scanner = MTBBarcodeScanner(previewView: previewView)
          
          previewView = UIView(frame: view.bounds)
          previewView.translatesAutoresizingMaskIntoConstraints = false
          view.addSubview(previewView)
          view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "V:[previewView]", options: .alignAllBottom, metrics: nil, views: [
               "previewView": previewView
               ]))
          view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "H:[previewView]", options: .alignAllBottom, metrics: nil, views: [
               "previewView": previewView
               ]))
          scanRect = ScannerOverlay(frame: view.bounds)
          scanRect.translatesAutoresizingMaskIntoConstraints = false
          scanRect.backgroundColor = UIColor.clear
          view.addSubview(scanRect)
          
          view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "V:[scanRect]", options: .alignAllBottom, metrics: nil, views: [
               "scanRect": scanRect
               ]))
          view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "H:[scanRect]", options: .alignAllBottom, metrics: nil, views: [
               "scanRect": scanRect
               ]))
          
          scanRect.startAnimating()
          scanner = MTBBarcodeScanner(previewView: previewView)
          navigationItem.leftBarButtonItem = UIBarButtonItem(barButtonSystemItem: .cancel, target: self, action: #selector(self.cancel))
          if(self.isSingleScan == false){
               navigationItem.rightBarButtonItem = UIBarButtonItem(barButtonSystemItem: .done, target: self, action: #selector(self.doneScanning))
          }
          updateFlashButton()
          
          
     }
     
     override func viewDidAppear(_ animated: Bool) {
          if ((scanner?.isScanning) != nil) {
               scanner?.stopScanning()
          }
          MTBBarcodeScanner.requestCameraPermission(success: { success in
               if success {
                    self.startScan()
               } else {
                    //self.delegate.barcodeScannerViewController(self, didFailWithErrorCode: "PERMISSION_NOT_GRANTED")
                    self.dismiss(animated: false)
               }
          })
     }
     
     
     
     /*@IBAction func nextButtonclick(_ sender: Any) {
      print("next Click")
      }*/
     
     
     override func viewWillAppear(_ animated: Bool) {
          /*MTBBarcodeScanner.requestCameraPermission(success: { success in
           if success {
           do {
           try self.scanner?.startScanning(resultBlock: { codes in
           if let codes = codes {
           for code in codes {
           let stringValue = code.stringValue!
           if(!self.itesm.contains(stringValue)){
           print("Found code: \(stringValue)")
           self.itesm.append(stringValue)
           
           self.countButton.setTitle("\(self.itesm.count)", for: .normal)
           
           // create a sound ID, in this case its the tweet sound.
           let systemSoundID: SystemSoundID = 1017
           
           // to play sound
           AudioServicesPlaySystemSound (systemSoundID)
           }
           }
           }
           })
           } catch {
           NSLog("Unable to start scanning")
           }
           } else {
           //UIAlertController(title: "Scanning Unavailable", message: "This app does not have permission to access the camera", delegate: nil, cancelButtonTitle: nil, otherButtonTitles: "Ok").show()
           
           let myalert = UIAlertController(title: "Scanning Unavailable", message: "This app does not have permission to access the camera", preferredStyle: UIAlertControllerStyle.alert)
           
           myalert.addAction(UIAlertAction(title: "ok", style: .default) { (action:UIAlertAction!) in
           print("Selected")
           })
           
           
           self.present(myalert, animated: true)
           }
           })*/
     }
     
     override func didReceiveMemoryWarning() {
          super.didReceiveMemoryWarning()
          // Dispose of any resources that can be recreated.
          
     }
     
     override func viewWillDisappear(_ animated: Bool) {
          
          
          super.viewWillDisappear(animated)
          
          scanner?.stopScanning()
          super.viewWillDisappear(animated)
          if isFlashOn() {
               toggleFlash(false)
          }
     }
     
     func startScan() {
          var error: Error?
          try? scanner?.startScanning(resultBlock: { codes in
               
               
               
               let code: AVMetadataMachineReadableCodeObject? = codes?.first
               if code != nil {
                    //self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: code?.stringValue)
                    
                    //self.dismiss(animated: false)
                    print("---------------")
                    print(codes)
                    print("---------------")
                    
                    var stringValue : String = (code?.stringValue)!
                    //codeScanned = stringValue
                    
                    
                    
                    print("stringValue code: \(stringValue)")
                    var isGoing = false
                    
                    if(stringValue.characters.count <= 14){
                         isGoing = true
                    }
                    
                    if(isGoing == false){
                         let swiftyString = stringValue.replacingOccurrences(of: "\"", with: "")
                         print("swiftyString:\(swiftyString)")
                         let trimmedString = swiftyString.trimmingCharacters(in: .whitespaces)
                         print("trimmedString:\(trimmedString)")
                         
                         //let group = trimmedString.components(separatedBy: "29")
                         //print(group)
                         
                         var ites:Int = 0
                         var finalStr:String = ""
                         var groupSaprator:String = ""
                         while(ites < trimmedString.characters.count){
                              let firstChar = Array(trimmedString)[ites]
                              print("char:\(firstChar)")
                              //let asc = trimmedString.index(trimmedString.startIndex, offsetBy: ites)
                              //print(asc)
                              let charAscii = firstChar.ascii
                              if(charAscii != 29){
                                   finalStr = finalStr + "\(firstChar)"
                              }else{
                                   finalStr = finalStr + "\(firstChar)"
                                   groupSaprator = "\(firstChar)"
                              }
                              
                              ites = ites + 1
                         }
                         
                         if(!finalStr.isEmpty){
                              if(!groupSaprator.isEmpty){
                                   let group = finalStr.components(separatedBy: groupSaprator)
                                   print(group)
                                   print(group[0])
                                   print(group[1])
                                   
                                   var str1:String = group[group.count - 1]
                                   print(str1)
                                   if(!str1.isEmpty){
                                        //let str2 = str1.removeAtIndex(enhance(str1.startIndex, 1))
                                        //let ffStr = str2.removeAtIndex(enhance(str2.startIndex, 1))
                                        
                                        if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                             str1.remove(at: index)
                                             print(str1) // prints "Hello I must be going"
                                        }
                                        
                                        if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                             str1.remove(at: index)
                                             print(str1) // prints "Hello I must be going"
                                        }
                                        
                                        stringValue = str1
                                        print("stringValue : \(stringValue)")
                                   }
                              }
                         }
                    }
                    
                    if(!self.itesm.contains(stringValue)){
                         print("Found code: \(stringValue)")
                         self.itesm.append(stringValue)
                         
                         if(self.isPlaySound){
                              //self.countButton.setTitle("\(self.itesm.count)", for: .normal)
                              // create a sound ID, in this case its the tweet sound.
                              let systemSoundID: SystemSoundID = 1017
                              // to play sound
                              AudioServicesPlaySystemSound (systemSoundID)
                         }
                         
                         if(self.isSingleScan){
                              self.scanner?.stopScanning()
                              //self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: stringValue)
                              self.dismiss(animated: false)
                         }
                    }
                    
                    
                    
                    /*if let codes = codes {
                     
                     var isAdded = false
                     var codeScanned = ""
                     
                     for code in codes {
                     let stringValue = code.stringValue!
                     codeScanned = stringValue
                     
                     if(self.itesm.contains(stringValue)){
                     break
                     }
                     
                     print("stringValue code: \(stringValue)")
                     var isGoing = false
                     
                     if(stringValue.characters.count <= 14){
                     isGoing = true
                     }
                     
                     if(isGoing == false){
                     let swiftyString = stringValue.replacingOccurrences(of: "\"", with: "")
                     let trimmedString = swiftyString.trimmingCharacters(in: .whitespaces)
                     
                     var ites:Int = 0
                     while(ites < trimmedString.characters.count){
                     let asc = trimmedString.index(trimmedString.startIndex, offsetBy: ites)
                     print(asc)
                     }
                     }
                     
                     if(!self.itesm.contains(stringValue)){
                     print("Found code: \(stringValue)")
                     self.itesm.append(stringValue)
                     
                     isAdded = true
                     }
                     }
                     
                     if(isAdded){
                     if(self.isPlaySound){
                     //self.countButton.setTitle("\(self.itesm.count)", for: .normal)
                     // create a sound ID, in this case its the tweet sound.
                     let systemSoundID: SystemSoundID = 1017
                     // to play sound
                     AudioServicesPlaySystemSound (systemSoundID)
                     }
                     
                     if(self.isSingleScan){
                     self.scanner?.stopScanning()
                     self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: codeScanned)
                     self.dismiss(animated: false)
                     }
                     }
                     }*/
               }
          })
     }
     
     @objc func cancel() {
          dismiss(animated: true)
     }
     
     func jsonData(from object:Any) -> String? {
          guard let data = try? JSONSerialization.data(withJSONObject: object, options: []) else {
               return nil
          }
          return String(data: data, encoding: String.Encoding.utf8)
     }
     
     @objc func doneScanning() {
          if(self.isSingleScan == false){
               self.scanner?.stopScanning()
               print("scan count:\(self.itesm.count)")
               let strr = jsonData(from: self.itesm)
               print("scan json:\(strr)")
               // self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: strr)
               self.dismiss(animated: false)
               
               /*self.scanner?.stopScanning()
                self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: stringValue)
                self.dismiss(animated: false)*/
          }
     }
     
     func updateFlashButton() {
          if !hasTorch {
               return
          }
          if isFlashOn() {
               navigationItem.rightBarButtonItem = UIBarButtonItem(title: "Flash Off", style: .plain, target: self, action: #selector(self.toggle))
          } else {
               navigationItem.rightBarButtonItem = UIBarButtonItem(title: "Flash On", style: .plain, target: self, action: #selector(self.toggle))
          }
     }
     
     @objc func toggle() {
          toggleFlash(!isFlashOn())
          updateFlashButton()
     }
     
     func isFlashOn() -> Bool {
          /*let device = AVCaptureDevice.default(for: .video)
           if device != nil {
           return device?.torchMode = AVCaptureDevice.FlashMode.on || device?.torchMode == .on
           }
           return false*/
          
          /* if self.videoDeviceInput.device.isFlashAvailable {
           
           if self.flashPhotoMode == .on {
           //photoSettings.flashMode = .on
           print("FLASH ON ")
           return true
           } else {
           print("FLASH OFF ")
           //photoSettings.flashMode = .off
           return false
           }
           
           }*/
          return false
          
     }
     
     var hasTorch: Bool {
          let device = AVCaptureDevice.default(for: .video)
          if device != nil {
               return device?.hasTorch ?? false
          }
          return false
     }
     
     func toggleFlash(_ on: Bool) {
          let device = AVCaptureDevice.default(for: .video)
          if device == nil {
               return
          }
          
          var err: Error?
          if device?.hasFlash ?? false && device?.hasTorch ?? false {
               try? device?.lockForConfiguration()
               if err != nil {
                    return
               }
               if on {
                    device?.flashMode = .on
                    device?.torchMode = .on
               } else {
                    device?.flashMode = .off
                    device?.torchMode = .off
               }
               device?.unlockForConfiguration()
          }
     }
     
}

extension Character {
     var isAscii: Bool {
          return unicodeScalars.allSatisfy { $0.isASCII }
     }
     var ascii: UInt32? {
          return isAscii ? unicodeScalars.first?.value : nil
     }
}

extension String {
     
     var length: Int {
          return count
     }
     
     subscript (i: Int) -> String {
          return self[i ..< i + 1]
     }
     
     func substring(fromIndex: Int) -> String {
          return self[min(fromIndex, length) ..< length]
     }
     
     func substring(toIndex: Int) -> String {
          return self[0 ..< max(0, toIndex)]
     }
     
     subscript (r: Range<Int>) -> String {
          let range = Range(uncheckedBounds: (lower: max(0, min(length, r.lowerBound)),
                                              upper: min(length, max(0, r.upperBound))))
          let start = index(startIndex, offsetBy: range.lowerBound)
          let end = index(start, offsetBy: range.upperBound - range.lowerBound)
          return String(self[start ..< end])
     }
     
     var bool: Bool? {
          switch self.lowercased() {
          case "true", "t", "yes", "y", "1":
               return true
          case "false", "f", "no", "n", "0":
               return false
          default:
               return nil
          }
     }
}

/*extension String {
 func aesEncrypt(key: String, iv: String) throws -> String{
 //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
 let data1 = self.data(using: .utf8)
 let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
 let encData = NSData(bytes: enc, length: Int(enc.count))
 let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
 let result = String(base64String)
 return result
 }
 
 func aesDecrypt(key: String, iv: String) throws -> String {
 //let data1 = NSData(base64Encoded: self, options: NSData.Base64DecodingOptions(rawValue: 0))
 let data1 = Data(base64Encoded: self)!
 let dec = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).decrypt(Array(data1))
 let decData = NSData(bytes: dec, length: Int(dec.count))
 let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
 //let result = String(bytes: Data(decData).bytes, encoding: .utf8)
 print(decData)
 //let result =  String(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
 return String(result!)
 }
 
 func aesEncrypt1(key: String, iv: String) throws -> String {
 
 
 let pwdBytes = [UInt8](key.utf8)
 var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
 var len = pwdBytes.count
 if(len > keyBytes.count){
 len = keyBytes.count
 //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
 }
 
 var i:Int = 0
 while(i < len){
 keyBytes[i] = pwdBytes[i]
 i = i + 1
 }
 
 let key1 = keyBytes
 let iv1 = keyBytes
 
 let encrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).encrypt([UInt8](self.data(using: .utf8)!))
 return Data(encrypted).base64EncodedString()
 }
 
 func aesDecrypt1(key: String, iv: String) throws -> String {
 
 let pwdBytes = [UInt8](key.utf8)
 var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
 var len = pwdBytes.count
 if(len > keyBytes.count){
 len = keyBytes.count
 //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
 }
 
 var i:Int = 0
 while(i < len){
 keyBytes[i] = pwdBytes[i]
 i = i + 1
 }
 
 let key1 = keyBytes
 let iv1 = keyBytes
 
 guard let data = Data(base64Encoded: self) else { return "" }
 let decrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).decrypt([UInt8](data))
 return String(bytes: Data(decrypted).bytes, encoding: .utf8) ?? "Could not decrypt"
 }
 }*/
     

//}
